//  
//  Copyright (C) 2009 Jason Smith, Robert Dyer
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 

using System;

namespace Docky.Services
{
	public interface IPreferences
	{
		T Get<T> (string name, T def);
		T GetSecure<T> (string name, T def);
		
		bool Set<T> (string name, T val);
		bool SetSecure<T> (string name, T val);
		
		string SanitizeKey (string key);
		
		void AddNotify (string path, GConf.NotifyEventHandler handler);
		void RemoveNotify (string path, GConf.NotifyEventHandler handler);
	}
}
